//-----------------------------------------------------------------------------
//      API_1_SSY_GETS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//      Package Definition
//-----------------------------------------------------------------------------
package sim.test.access.api_1_ssy_gets;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.access.*;
import sim.toolkit.* ;
import javacard.framework.* ;

import sim.test.util.* ;

/**
 * Test Area : getTheSIMView() method
 *
 * Applet is triggered on EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 29/11/00
 * @autor 3GPP T3 SWG API
 *
 * @see sim.access.SIMSystem
 *
 */
public class API_1_SSY_GETS_1 extends TestToolkitApplet {

  /**
   * Constructor of the applet
   */
	private ToolkitRegistry obReg ;
	private  SIMView theGsmApplet;
	private byte[] buffer = new byte[(short) 30];

  public API_1_SSY_GETS_1()
  {
  }


  /**
   * Method called by the JCRE at the installation of the applet
*/
  public static void install(byte bArray[], short bOffset, byte bLength)
  {
    // Create a new applet instance
    API_1_SSY_GETS_1 thisApplet = new API_1_SSY_GETS_1();

    // Register the new applet instance to the JCRE
    thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

	// Initialise the data of the test applet
    thisApplet.init();
  }


  /**
   * Method called by the SIM Toolkit Framework
   */
  public void processToolkit(byte event) {
    // Number of tests
    byte testCaseNb = (byte)0;
    // Result of tests
    boolean bRes = false;

      // --------------------------------------------
      // Test Case 1 : reference not equal null
      testCaseNb = (byte)1;
	  bRes = false ;

	  if ( theGsmApplet == null) {
      	theGsmApplet = SIMSystem.getTheSIMView();
	  	if ( theGsmApplet != null) {
          bRes = true ;
		}
      }
      reportTestOutcome(testCaseNb, bRes) ;


      // --------------------------------------------
      // Test Case 2 : return a referenz to the GSM interface
      testCaseNb = (byte)2;
	  bRes = false ;

	  if (theGsmApplet instanceof sim.access.SIMView) {
          	bRes = true ;
	    }

      reportTestOutcome(testCaseNb, bRes) ;


      // End of the Test Sequence
  }
}
