//-----------------------------------------------------------------------------
//    FWK_TIN_TMAL_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_tin_tmal ;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.framework Toolkit Installation
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 26/09/01
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.framework
 */
public class FWK_TIN_TMAL_1 extends TestToolkitApplet
{
                
    /**
     * Constructor of the applet
     */
    public FWK_TIN_TMAL_1() 
    {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        FWK_TIN_TMAL_1 thisApplet = new FWK_TIN_TMAL_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);
   
    	// Initialise the data of the test applet
   	thisApplet.init();
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {                 
    	// Result of each test
    	boolean bRes ;
    	
    	// Number of tests
    	byte testCaseNb;
    	    	
    	// --------------------------------------------
        // Test Case 1 : Allocate 8 timers     
        testCaseNb = (byte) 1 ;
        bRes = false ;

        try {
            obReg.allocateTimer();
    	    obReg.allocateTimer();
            obReg.allocateTimer();
            obReg.allocateTimer();
            obReg.allocateTimer();
    	    obReg.allocateTimer();
            obReg.allocateTimer();
            obReg.allocateTimer();
           bRes = true ;
        }
	catch (Exception e) {	
		bRes = false;
	}
	 reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 2 : Allocate one more timer     
       testCaseNb = (byte) 2 ;
        bRes = false ;

        try {
            obReg.allocateTimer();            
        }
	catch (ToolkitException e) {
		bRes = (e.getReason()==ToolkitException.NO_TIMER_AVAILABLE);
	}
        reportTestOutcome(testCaseNb, bRes) ;
    }
}
