//-----------------------------------------------------------------------------
//    FWK_APT_EMCN_s.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_emcn;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering
 *
 * Applet is triggered on Install (Install, all events
 *
 * @version 0.0.1 - 15/11/01
 *
 */

 public class FWK_APT_EMCN_2 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private byte[] TEXT ={'T','e','x','t',' ','1'};
     private boolean bRes;
     private byte nbCases = (byte)0x00;


    //Constructor of the applet

    public FWK_APT_EMCN_2(){

    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_APT_EMCN_2 thisApplet = new FWK_APT_EMCN_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
        //Prepare result table for test that the applet is not triggered when is deregistered
        //to the event
        thisApplet.baTestsResults[(byte)0x01]=(byte)0xCC;
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

       bRes=false;
       if(event==EVENT_FORMATTED_SMS_PP_ENV ){
            //TEST CASE 1: A PROACTIVE COMMAND IS SENT AND THE APPLET IS REGISTERED TO
            //THE EVENT
            testCaseNb=(byte)0x02;
             try{
                ProactiveHandler prHdlr = ProactiveHandler.getTheHandler();
                prHdlr.initDisplayText((byte)0x80,DCS_8_BIT_DATA,TEXT,(short)0x00,(short)TEXT.length);
                prHdlr.send();
                obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
                nbCases=(byte)0x01;
                bRes=true;
             }
             catch(Exception e){
                bRes=false;
             }
             reportTestOutcome(testCaseNb,bRes);
       }


     if(event==EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM){
	//Test tha the applet is not triggered when is not registered to the event and is triggered
	//when is registered
        switch(nbCases){
            case (byte)0x00:
                 testCaseNb=0x01;
                 bRes=false;
                 reportTestOutcome(testCaseNb,bRes);
            break;
            case (byte)0x01:
     	        testCaseNb=0x03;
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
        }
     }
  }
 }