//-----------------------------------------------------------------------------
//    FWK_MHA_PAHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_mha_pahd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Availability
 *
 * Applet is triggered on Install (Install, all events
 *
 */

 public class FWK_MHA_PAHD_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private byte[] MenuEntry1 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'1'};
     private byte[] MenuEntry2 = {(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'2'};
     private byte[] eventList ={EVENT_PROFILE_DOWNLOAD,EVENT_UNFORMATTED_SMS_PP_ENV,EVENT_FORMATTED_SMS_CB,EVENT_UNFORMATTED_SMS_CB,
                                EVENT_CALL_CONTROL_BY_SIM,EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,EVENT_EVENT_DOWNLOAD_MT_CALL,
                                EVENT_EVENT_DOWNLOAD_CALL_CONNECTED,EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED,EVENT_EVENT_DOWNLOAD_LOCATION_STATUS,
                                EVENT_EVENT_DOWNLOAD_USER_ACTIVITY,EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE,EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS,
                                EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION,EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION,EVENT_UNRECOGNIZED_ENVELOPE};
     private boolean bRes;
     
     private byte a;
	
    //Constructor of the applet

    public FWK_MHA_PAHD_1(){
        //register to EVENT_MENU_SELECTION
        obReg.initMenuEntry(MenuEntry1,(short)0,(short)MenuEntry1.length,(byte)0,false,(byte)0,(short)0);
        //register to EVENT_MENU_SELECTION_HELP_REQUEST
        obReg.initMenuEntry(MenuEntry2,(short)0,(short)MenuEntry2.length,(byte)0,true,(byte)0,(short)0);
        //register to EVENT_TIMER_EXPIRATION
        for(a=0; a<(byte)8; a++){
       	   	obReg.allocateTimer();
       	}
       	for(a=2; a<(byte)9; a++){
       		obReg.releaseTimer((byte)a);       	   		
       	}
        //register to EVENT_STATUS_COMMAND
        obReg.requestPollInterval((short)POLL_SYSTEM_DURATION);
        //register to the rest of the events included the event download events
        obReg.setEventList(eventList,(short)0,(short)eventList.length);

    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instance
        FWK_MHA_PAHD_1 thisApplet = new FWK_MHA_PAHD_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

    //for each event the handler must be availiable
        testCaseNb++;
        bRes=false;
        switch(event){

            //event EVENT_PROFILE_DOWNLOAD
            case EVENT_PROFILE_DOWNLOAD:
                try{
                    //get the Proactive Handler
                    ProactiveHandler proHdlr=ProactiveHandler.getTheHandler();
                    //deregister to EVENT_PROFILE_DOWNLOAD
                    obReg.clearEvent(event);
                    bRes=true;
                }
                catch(Exception e){
                    bRes=false;
                }
                reportTestOutcome(testCaseNb,bRes);
            break;

            //rest of the events registered
            default:

            try{
                //get the Proactive Handler
                ProactiveHandler proHdlr = ProactiveHandler.getTheHandler();
                bRes=true;
            }
            catch(Exception e){
                bRes=false;
            }
            reportTestOutcome(testCaseNb,bRes);
        }

    }

 }