//-----------------------------------------------------------------------------
//    FWK_API_TRAN_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_api_tran;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : Transaction
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 10/12/01
 *
 */
public class FWK_API_TRAN_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};
	
	private static byte[] testArray = {(byte)0xFF};
	
    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public FWK_API_TRAN_1 () 
    {
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        FWK_API_TRAN_1  thisApplet = new FWK_API_TRAN_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
                
		// --------------------------------------------
		// Test Case 1 : Verify a pending transaction is aborted
		testCaseNb = (byte) 1 ;

		bRes = false ;
		testArray[0] = (byte) 0x05;
		try {
			JCSystem.beginTransaction();
			testArray[0] = (byte) 0x02;
			//send  proactive command to have the ProactiveResponseHandler available
			ProactiveHandler.getTheHandler().initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
			(ProactiveHandler.getTheHandler()).send();
			if ( (testArray[0]==(byte)5) && (JCSystem.getTransactionDepth()==0) )
				bRes = true;
		}
		catch (Exception e)    {    
		}

		reportTestOutcome(testCaseNb, bRes) ;

	}
}
