//-----------------------------------------------------------------------------
//    FWK_APT_ECCN_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_eccn;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering
 *
 * Applet is triggered on Install (Install, all events
 *
 * @version 0.0.1 - 15/11/01
 *
 */

 public class FWK_APT_ECCN_1 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private boolean bRes=false;

    //Constructor of the applet

    public FWK_APT_ECCN_1(){
        //register to EVENT_UNFORMATTED_SMS_PP_ENV
        obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_APT_ECCN_1 thisApplet = new FWK_APT_ECCN_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

        switch(testCaseNb){
	    //TestCase 1: The applet must be triggered
            case (byte)0x00:
                testCaseNb=(byte)0x01;
                bRes=true;
                reportTestOutcome(testCaseNb,bRes);
           break;

           case (byte)0x01:
		//TestCase 2: clearEvent method is called and applet is unregistered
                testCaseNb=(byte)0x02;
                try{
                    obReg.clearEvent(EVENT_CALL_CONTROL_BY_SIM);
                    bRes=true;
                }
                catch(Exception e){
                    bRes=false;
                }
                reportTestOutcome(testCaseNb,bRes);
                reportTestOutcome((byte)0x03,true);
                break;
           case (byte) 0x02:
		//TestCase 3: Applet has been registered and must be triggered
                testCaseNb=(byte)0x03;
                bRes=false;
                reportTestOutcome(testCaseNb,bRes);
        }

    }


 }