//-----------------------------------------------------------------------------
//    API_2_TKR_GETY_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_gety;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.getEntry() method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 15/01/01
 *
 */
public class API_2_TKR_GETY_1 extends TestToolkitApplet
{

	private ToolkitRegistry Ref;

    /**
     * Constructor of the applet
     */
    public API_2_TKR_GETY_1() 
    {
		// -----------------------------------------------------------------
		// Test Case 1 :Initialization
		//				In the constructor, 
		//				the applet instance calls the getEntry() method
		// -----------------------------------------------------------------

		try{
			Ref = obReg.getEntry();
		}
		catch (Exception e) {
		}
    }

    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_TKR_GETY_1 thisApplet = new API_2_TKR_GETY_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x02;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;
    

			// -----------------------------------------------------------------
			// Test Case 1 :getEntry() in the constructor
			//				Returns a not null ToolkitRegistry instance
			// -----------------------------------------------------------------
        
			testCaseNb = (byte) 1 ;
			bRes = false;

			bRes = !(Ref == null);
			reportTestOutcome(testCaseNb, bRes) ;
        
			
			// -----------------------------------------------------------------
			// Test Case 2 :The applet calls the getEntry() method again
			//				Returns the same as ToolkitRegistry instance
			// -----------------------------------------------------------------
        
			testCaseNb = (byte) 2 ;
			bRes = false;

			try {            
				bRes = Ref == obReg.getEntry();
			} 
			catch (Exception e) {	//No exceptions should be thrown
				bRes = false ;
			}

		
			reportTestOutcome(testCaseNb, bRes) ;
	}
}
